

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>oxdpython.client &mdash; oxD Python 2.4.4-rc documentation</title>
  

  
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
  

  

  
    <link rel="top" title="oxD Python 2.4.4-rc documentation" href="../../index.html"/>
        <link rel="up" title="Module code" href="../index.html"/> 

  
  <script src="../../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../../index.html" class="icon icon-home"> oxD Python
          

          
          </a>

          
            
            
              <div class="version">
                2.4.4
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
                <!-- Local TOC -->
                <div class="local-toc"></div>
            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="../../index.html">oxD Python</a>
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          





<div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../../index.html">Docs</a> &raquo;</li>
      
          <li><a href="../index.html">Module code</a> &raquo;</li>
      
    <li>oxdpython.client</li>
      <li class="wy-breadcrumbs-aside">
        
          
        
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for oxdpython.client</h1><div class="highlight"><pre>
<span></span><span class="kn">import</span> <span class="nn">logging</span>

<span class="kn">from</span> <span class="nn">.configurer</span> <span class="kn">import</span> <span class="n">Configurer</span>
<span class="kn">from</span> <span class="nn">.messenger</span> <span class="kn">import</span> <span class="n">Messenger</span>

<span class="n">logger</span> <span class="o">=</span> <span class="n">logging</span><span class="o">.</span><span class="n">getLogger</span><span class="p">(</span><span class="n">__name__</span><span class="p">)</span>


<div class="viewcode-block" id="Client"><a class="viewcode-back" href="../../index.html#oxdpython.client.Client">[docs]</a><span class="k">class</span> <span class="nc">Client</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;Client is the main class that carries out the commands to talk with the</span>
<span class="sd">    oxD server. The oxD request commands are provided as class methods that</span>
<span class="sd">    can be called to send the command to the oxD server via socket and the</span>
<span class="sd">    reponse is returned as a dict by the called method.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">config_location</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Constructor of class Client</span>
<span class="sd">        Args:</span>
<span class="sd">            config_location (string): The complete path of the location</span>
<span class="sd">                of the config file which is a modified conpy of the sample.cfg</span>
<span class="sd">                from this library</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">config</span> <span class="o">=</span> <span class="n">Configurer</span><span class="p">(</span><span class="n">config_location</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">msgr</span> <span class="o">=</span> <span class="n">Messenger</span><span class="p">(</span><span class="nb">int</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">config</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;oxd&quot;</span><span class="p">,</span> <span class="s2">&quot;port&quot;</span><span class="p">)))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">op_host</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">config</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;client&quot;</span><span class="p">,</span> <span class="s2">&quot;op_host&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">application_type</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">config</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;client&quot;</span><span class="p">,</span> <span class="s2">&quot;application_type&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">authorization_redirect_uri</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">config</span><span class="o">.</span><span class="n">get</span><span class="p">(</span>
            <span class="s2">&quot;client&quot;</span><span class="p">,</span> <span class="s2">&quot;authorization_redirect_uri&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">oxd_id</span> <span class="o">=</span> <span class="bp">None</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">config</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;oxd&quot;</span><span class="p">,</span> <span class="s2">&quot;id&quot;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">oxd_id</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">config</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;oxd&quot;</span><span class="p">,</span> <span class="s2">&quot;id&quot;</span><span class="p">)</span>

            <span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;Oxd ID found during initialization. Client is&quot;</span>
                        <span class="s2">&quot; already registered with the OpenID Provider&quot;</span><span class="p">)</span>
            <span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;oxd id: </span><span class="si">%s</span><span class="s2">&quot;</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">oxd_id</span><span class="p">)</span>

    <span class="k">def</span> <span class="nf">__clear_data</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">response</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;A private method that verifies that the oxd response is error free</span>
<span class="sd">        and raises a RuntimeError when it encounters an error</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="n">response</span><span class="o">.</span><span class="n">status</span> <span class="o">==</span> <span class="s2">&quot;error&quot;</span><span class="p">:</span>
            <span class="n">error</span> <span class="o">=</span> <span class="s2">&quot;OxD Server Error: {0}</span><span class="se">\n</span><span class="s2">Description:{1}&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span>
                    <span class="n">response</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">error</span><span class="p">,</span> <span class="n">response</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">error_description</span><span class="p">)</span>
            <span class="n">logger</span><span class="o">.</span><span class="n">error</span><span class="p">(</span><span class="n">error</span><span class="p">)</span>
            <span class="k">raise</span> <span class="ne">RuntimeError</span><span class="p">(</span><span class="n">error</span><span class="p">)</span>
        <span class="k">elif</span> <span class="n">response</span><span class="o">.</span><span class="n">status</span> <span class="o">==</span> <span class="s2">&quot;ok&quot;</span><span class="p">:</span>
            <span class="k">return</span> <span class="n">response</span><span class="o">.</span><span class="n">data</span>

<div class="viewcode-block" id="Client.register_site"><a class="viewcode-back" href="../../index.html#oxdpython.client.Client.register_site">[docs]</a>    <span class="k">def</span> <span class="nf">register_site</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Function to register the site and generate a unique ID for the site</span>

<span class="sd">        Returns:</span>
<span class="sd">            string: The ID of the site (also called client id) if the</span>
<span class="sd">            registration is sucessful</span>

<span class="sd">        Raises:</span>
<span class="sd">            RuntimeError: If the site registration fails.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">oxd_id</span><span class="p">:</span>
            <span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s1">&#39;Client is already registered. ID: </span><span class="si">%s</span><span class="s1">&#39;</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">oxd_id</span><span class="p">)</span>
            <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">oxd_id</span>

        <span class="n">command</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;command&quot;</span><span class="p">:</span> <span class="s2">&quot;register_site&quot;</span><span class="p">}</span>

        <span class="c1"># add required params for the command</span>
        <span class="n">params</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;op_host&quot;</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">op_host</span><span class="p">,</span>
                  <span class="s2">&quot;authorization_redirect_uri&quot;</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">authorization_redirect_uri</span>
                  <span class="p">}</span>
        <span class="c1"># add other optional params if they exist in config</span>
        <span class="n">opt_params</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;post_logout_redirect_uri&quot;</span><span class="p">,</span>
                      <span class="s2">&quot;client_jwks_uri&quot;</span><span class="p">,</span>
                      <span class="s2">&quot;client_token_endpoint_auth_method&quot;</span><span class="p">,</span>
                      <span class="s2">&quot;application_type&quot;</span><span class="p">]</span>
        <span class="n">opt_list_params</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;grant_types&quot;</span><span class="p">,</span>
                           <span class="s2">&quot;acr_values&quot;</span><span class="p">,</span>
                           <span class="s2">&quot;redirect_uris&quot;</span><span class="p">,</span>
                           <span class="s2">&quot;contacts&quot;</span><span class="p">,</span>
                           <span class="s2">&quot;client_logout_uris&quot;</span><span class="p">,</span>
                           <span class="s2">&quot;client_request_uris&quot;</span><span class="p">]</span>
        <span class="k">for</span> <span class="n">param</span> <span class="ow">in</span> <span class="n">opt_params</span><span class="p">:</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">config</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;client&quot;</span><span class="p">,</span> <span class="n">param</span><span class="p">):</span>
                <span class="n">value</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">config</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;client&quot;</span><span class="p">,</span> <span class="n">param</span><span class="p">)</span>
                <span class="n">params</span><span class="p">[</span><span class="n">param</span><span class="p">]</span> <span class="o">=</span> <span class="n">value</span>

        <span class="k">for</span> <span class="n">param</span> <span class="ow">in</span> <span class="n">opt_list_params</span><span class="p">:</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">config</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;client&quot;</span><span class="p">,</span> <span class="n">param</span><span class="p">):</span>
                <span class="n">value</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">config</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;client&quot;</span><span class="p">,</span> <span class="n">param</span><span class="p">)</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s2">&quot;,&quot;</span><span class="p">)</span>
                <span class="n">params</span><span class="p">[</span><span class="n">param</span><span class="p">]</span> <span class="o">=</span> <span class="n">value</span>

        <span class="n">command</span><span class="p">[</span><span class="s2">&quot;params&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">params</span>
        <span class="n">logger</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="s2">&quot;Sending command `register_site` with params </span><span class="si">%s</span><span class="s2">&quot;</span><span class="p">,</span>
                     <span class="n">params</span><span class="p">)</span>
        <span class="n">response</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">msgr</span><span class="o">.</span><span class="n">send</span><span class="p">(</span><span class="n">command</span><span class="p">)</span>
        <span class="n">logger</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="s2">&quot;Recieved reponse: </span><span class="si">%s</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">response</span><span class="p">)</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">oxd_id</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">__clear_data</span><span class="p">(</span><span class="n">response</span><span class="p">)</span><span class="o">.</span><span class="n">oxd_id</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">config</span><span class="o">.</span><span class="n">set</span><span class="p">(</span><span class="s2">&quot;oxd&quot;</span><span class="p">,</span> <span class="s2">&quot;id&quot;</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">oxd_id</span><span class="p">)</span>
        <span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;Site registration successful. Oxd ID: </span><span class="si">%s</span><span class="s2">&quot;</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">oxd_id</span><span class="p">)</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">oxd_id</span></div>

<div class="viewcode-block" id="Client.get_authorization_url"><a class="viewcode-back" href="../../index.html#oxdpython.client.Client.get_authorization_url">[docs]</a>    <span class="k">def</span> <span class="nf">get_authorization_url</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">acr_values</span><span class="o">=</span><span class="bp">None</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Function to get the authorization url that can be opened in the</span>
<span class="sd">        browser for the user to provide authorization and authentication</span>

<span class="sd">        Args:</span>
<span class="sd">            acr_values (list, optional): acr values in the order of priority</span>

<span class="sd">        Returns:</span>
<span class="sd">            string: The authorization url that the user must access for</span>
<span class="sd">            authentication and authorization</span>

<span class="sd">        Raises:</span>
<span class="sd">            RuntimeError: If the oxD throws an error for any reason.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">command</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;command&quot;</span><span class="p">:</span> <span class="s2">&quot;get_authorization_url&quot;</span><span class="p">}</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="bp">self</span><span class="o">.</span><span class="n">oxd_id</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">register_site</span><span class="p">()</span>

        <span class="n">params</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;oxd_id&quot;</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">oxd_id</span><span class="p">}</span>

        <span class="k">if</span> <span class="n">acr_values</span> <span class="ow">and</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">acr_values</span><span class="p">,</span> <span class="nb">list</span><span class="p">):</span>
            <span class="n">params</span><span class="p">[</span><span class="s2">&quot;acr_values&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">acr_values</span>

        <span class="n">command</span><span class="p">[</span><span class="s2">&quot;params&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">params</span>
        <span class="n">logger</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="s2">&quot;Sending command `get_authorization_url` with params </span><span class="si">%s</span><span class="s2">&quot;</span><span class="p">,</span>
                     <span class="n">params</span><span class="p">)</span>
        <span class="n">response</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">msgr</span><span class="o">.</span><span class="n">send</span><span class="p">(</span><span class="n">command</span><span class="p">)</span>
        <span class="n">logger</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="s2">&quot;Recieved reponse: </span><span class="si">%s</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">response</span><span class="p">)</span>

        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">__clear_data</span><span class="p">(</span><span class="n">response</span><span class="p">)</span><span class="o">.</span><span class="n">authorization_url</span></div>

<div class="viewcode-block" id="Client.get_tokens_by_code"><a class="viewcode-back" href="../../index.html#oxdpython.client.Client.get_tokens_by_code">[docs]</a>    <span class="k">def</span> <span class="nf">get_tokens_by_code</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">code</span><span class="p">,</span> <span class="n">scopes</span><span class="p">,</span> <span class="n">state</span><span class="o">=</span><span class="bp">None</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Function to get access code for getting the user details from the</span>
<span class="sd">        OP. It is called after the user authorizies by visiting the auth URL.</span>

<span class="sd">        Args:</span>
<span class="sd">            code (string): code, parse from the callback URL querystring</span>
<span class="sd">            scopes (list): scopes authorized by the OP, parsed from the</span>
<span class="sd">                callback URL</span>
<span class="sd">            state (string, optional): state, parsed from the callback URL</span>

<span class="sd">        Returns:</span>
<span class="sd">            NamedTuple: The tokens object with the following data structure::</span>

<span class="sd">                {</span>
<span class="sd">                    &quot;access_token&quot;: &quot;&lt;token string&gt;&quot;,</span>
<span class="sd">                    &quot;expires_in&quot;: 3600,</span>
<span class="sd">                    &quot;refresh_token&quot;: &quot;&lt;token string&gt;&quot;,</span>
<span class="sd">                    &quot;id_token&quot;: &quot;&lt;token string&gt;&quot;,</span>
<span class="sd">                    &quot;id_token_claims&quot;:</span>
<span class="sd">                    {</span>
<span class="sd">                        &quot;iss&quot;: &quot;https://server.example.com&quot;,</span>
<span class="sd">                        &quot;sub&quot;: &quot;24400320&quot;,</span>
<span class="sd">                        &quot;aud&quot;: &quot;s6BhdRkqt3&quot;,</span>
<span class="sd">                        &quot;nonce&quot;: &quot;n-0S6_WzA2Mj&quot;,</span>
<span class="sd">                        &quot;exp&quot;: 1311281970,</span>
<span class="sd">                        &quot;iat&quot;: 1311280970,</span>
<span class="sd">                        &quot;at_hash&quot;: &quot;MTIzNDU2Nzg5MDEyMzQ1Ng&quot;</span>
<span class="sd">                    }</span>
<span class="sd">                }</span>

<span class="sd">            Since this would be returned as a NamedTuple, it can be accessed</span>
<span class="sd">            using the dot notation as :obj:`data.access_token`,</span>
<span class="sd">            :obj:`data.refresh_token`, :obj:`data.id_token`...etc.,</span>

<span class="sd">        Raises:</span>
<span class="sd">            RuntimeError: If oxD server throws an error OR if the params code</span>
<span class="sd">                and scopes are of improper datatype.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="p">(</span><span class="n">code</span> <span class="ow">and</span> <span class="n">scopes</span><span class="p">)</span> <span class="ow">or</span> <span class="nb">type</span><span class="p">(</span><span class="n">scopes</span><span class="p">)</span> <span class="o">!=</span> <span class="nb">list</span><span class="p">:</span>
            <span class="n">err_msg</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;Empty/Wrong value in place of code or scope.</span>
<span class="s2">                      Code (string): {0}</span>
<span class="s2">                      Scopes (list): {1}&quot;&quot;&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">code</span><span class="p">,</span> <span class="n">scopes</span><span class="p">)</span>
            <span class="n">logger</span><span class="o">.</span><span class="n">error</span><span class="p">(</span><span class="n">err_msg</span><span class="p">)</span>
            <span class="k">raise</span> <span class="ne">RuntimeError</span><span class="p">(</span><span class="n">err_msg</span><span class="p">)</span>

        <span class="n">command</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;command&quot;</span><span class="p">:</span> <span class="s2">&quot;get_tokens_by_code&quot;</span><span class="p">}</span>
        <span class="n">params</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;oxd_id&quot;</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">oxd_id</span><span class="p">}</span>
        <span class="n">params</span><span class="p">[</span><span class="s2">&quot;code&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">code</span>
        <span class="n">params</span><span class="p">[</span><span class="s2">&quot;scopes&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">scopes</span>

        <span class="k">if</span> <span class="n">state</span><span class="p">:</span>
            <span class="n">params</span><span class="p">[</span><span class="s2">&quot;state&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">state</span>

        <span class="n">command</span><span class="p">[</span><span class="s2">&quot;params&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">params</span>
        <span class="n">logger</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="s2">&quot;Sending command `get_tokens_by_code` with params </span><span class="si">%s</span><span class="s2">&quot;</span><span class="p">,</span>
                     <span class="n">params</span><span class="p">)</span>
        <span class="n">response</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">msgr</span><span class="o">.</span><span class="n">send</span><span class="p">(</span><span class="n">command</span><span class="p">)</span>
        <span class="n">logger</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="s2">&quot;Recieved reponse: </span><span class="si">%s</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">response</span><span class="p">)</span>

        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">__clear_data</span><span class="p">(</span><span class="n">response</span><span class="p">)</span></div>

<div class="viewcode-block" id="Client.get_user_info"><a class="viewcode-back" href="../../index.html#oxdpython.client.Client.get_user_info">[docs]</a>    <span class="k">def</span> <span class="nf">get_user_info</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">access_token</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Function to get the information about the user using the access code</span>
<span class="sd">        obtained from the OP</span>

<span class="sd">        Args:</span>
<span class="sd">            access_token (string): access token from the get_tokens_by_code</span>
<span class="sd">                                    function</span>

<span class="sd">        Returns:</span>
<span class="sd">            NamedTuple: The user data claims that are returned by the OP.</span>
<span class="sd">            Refer to the /.well-known/openid-configuration URL of your OP for</span>
<span class="sd">            the complete list of the claims for different scopes.</span>

<span class="sd">        Raises:</span>
<span class="sd">            RuntimeError: If the param access_token is empty OR if the oxD</span>
<span class="sd">                Server returns an error.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="n">access_token</span><span class="p">:</span>
            <span class="n">logger</span><span class="o">.</span><span class="n">error</span><span class="p">(</span><span class="s2">&quot;Empty access code sent for get_user_info&quot;</span><span class="p">)</span>
            <span class="k">raise</span> <span class="ne">RuntimeError</span><span class="p">(</span><span class="s2">&quot;Empty access code&quot;</span><span class="p">)</span>

        <span class="n">command</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;command&quot;</span><span class="p">:</span> <span class="s2">&quot;get_user_info&quot;</span><span class="p">}</span>
        <span class="n">params</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;oxd_id&quot;</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">oxd_id</span><span class="p">}</span>
        <span class="n">params</span><span class="p">[</span><span class="s2">&quot;access_token&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">access_token</span>
        <span class="n">command</span><span class="p">[</span><span class="s2">&quot;params&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">params</span>
        <span class="n">logger</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="s2">&quot;Sending command `get_user_info` with params </span><span class="si">%s</span><span class="s2">&quot;</span><span class="p">,</span>
                     <span class="n">params</span><span class="p">)</span>
        <span class="n">response</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">msgr</span><span class="o">.</span><span class="n">send</span><span class="p">(</span><span class="n">command</span><span class="p">)</span>
        <span class="n">logger</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="s2">&quot;Recieved reponse: </span><span class="si">%s</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">response</span><span class="p">)</span>

        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">__clear_data</span><span class="p">(</span><span class="n">response</span><span class="p">)</span><span class="o">.</span><span class="n">claims</span></div>

<div class="viewcode-block" id="Client.get_logout_uri"><a class="viewcode-back" href="../../index.html#oxdpython.client.Client.get_logout_uri">[docs]</a>    <span class="k">def</span> <span class="nf">get_logout_uri</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">id_token_hint</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span> <span class="n">post_logout_redirect_uri</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span>
                       <span class="n">state</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span> <span class="n">session_state</span><span class="o">=</span><span class="bp">None</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Function to logout the user.</span>

<span class="sd">        Args:</span>
<span class="sd">            id_token_hint (string, optional): oxd server will use last used</span>
<span class="sd">                ID Token, if not provided</span>
<span class="sd">            post_logout_redirect_uri (string, optional): URI to redirect,</span>
<span class="sd">                this uri would override the value given in the site-config</span>
<span class="sd">            state (string, optional): site state</span>
<span class="sd">            session_state (string, optional): session state</span>

<span class="sd">        Returns:</span>
<span class="sd">            string: The URI to which the user must be directed in order to</span>
<span class="sd">            perform the logout</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">command</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;command&quot;</span><span class="p">:</span> <span class="s2">&quot;get_logout_uri&quot;</span><span class="p">}</span>
        <span class="n">params</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;oxd_id&quot;</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">oxd_id</span><span class="p">}</span>
        <span class="k">if</span> <span class="n">id_token_hint</span><span class="p">:</span>
            <span class="n">params</span><span class="p">[</span><span class="s2">&quot;id_token_hint&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">id_token_hint</span>

        <span class="k">if</span> <span class="n">post_logout_redirect_uri</span><span class="p">:</span>
            <span class="n">params</span><span class="p">[</span><span class="s2">&quot;post_logout_redirect_uri&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">post_logout_redirect_uri</span>
        <span class="k">elif</span> <span class="bp">self</span><span class="o">.</span><span class="n">config</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;client&quot;</span><span class="p">,</span> <span class="s2">&quot;logout_redirect_uri&quot;</span><span class="p">):</span>
            <span class="n">params</span><span class="p">[</span><span class="s2">&quot;post_logout_redirect_uri&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">config</span><span class="o">.</span><span class="n">get</span><span class="p">(</span>
                <span class="s2">&quot;client&quot;</span><span class="p">,</span> <span class="s2">&quot;logout_redirect_uri&quot;</span>
                <span class="p">)</span>

        <span class="k">if</span> <span class="n">state</span><span class="p">:</span>
            <span class="n">params</span><span class="p">[</span><span class="s2">&quot;state&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">state</span>

        <span class="k">if</span> <span class="n">session_state</span><span class="p">:</span>
            <span class="n">params</span><span class="p">[</span><span class="s2">&quot;session_state&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">session_state</span>

        <span class="n">command</span><span class="p">[</span><span class="s2">&quot;params&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">params</span>

        <span class="n">logger</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="s2">&quot;Sending command `get_logout_uri` with params </span><span class="si">%s</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">params</span><span class="p">)</span>
        <span class="n">response</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">msgr</span><span class="o">.</span><span class="n">send</span><span class="p">(</span><span class="n">command</span><span class="p">)</span>
        <span class="n">logger</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="s2">&quot;Recieved response: </span><span class="si">%s</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">response</span><span class="p">)</span>

        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">__clear_data</span><span class="p">(</span><span class="n">response</span><span class="p">)</span><span class="o">.</span><span class="n">uri</span></div>

<div class="viewcode-block" id="Client.update_site_registration"><a class="viewcode-back" href="../../index.html#oxdpython.client.Client.update_site_registration">[docs]</a>    <span class="k">def</span> <span class="nf">update_site_registration</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Fucntion to update the site&#39;s information with OpenID Provider.</span>
<span class="sd">        This should be called after changing the values in the cfg file.</span>

<span class="sd">        Returns:</span>
<span class="sd">            bool: The status for update. True for success and False for failure</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">command</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;command&quot;</span><span class="p">:</span> <span class="s2">&quot;update_site_registration&quot;</span><span class="p">}</span>
        <span class="n">params</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;oxd_id&quot;</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">oxd_id</span><span class="p">,</span>
                  <span class="s2">&quot;authorization_redirect_uri&quot;</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">authorization_redirect_uri</span>
                  <span class="p">}</span>
        <span class="n">optional_params</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;post_logout_redirect_uri&quot;</span><span class="p">,</span> <span class="s2">&quot;application_type&quot;</span><span class="p">,</span>
                           <span class="s2">&quot;client_jwks_uri&quot;</span><span class="p">,</span>
                           <span class="s2">&quot;client_token_endpoint_auth_method&quot;</span><span class="p">]</span>
        <span class="n">optional_list_params</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;client_logout_uris&quot;</span><span class="p">,</span> <span class="s2">&quot;grant_types&quot;</span><span class="p">,</span>
                                <span class="s2">&quot;redirect_uris&quot;</span><span class="p">,</span> <span class="s2">&quot;acr_values&quot;</span><span class="p">,</span>
                                <span class="s2">&quot;client_request_uris&quot;</span><span class="p">,</span> <span class="s2">&quot;contacts&quot;</span><span class="p">]</span>
        <span class="k">for</span> <span class="n">param</span> <span class="ow">in</span> <span class="n">optional_params</span><span class="p">:</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">config</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;client&quot;</span><span class="p">,</span> <span class="n">param</span><span class="p">):</span>
                <span class="n">value</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">config</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;client&quot;</span><span class="p">,</span> <span class="n">param</span><span class="p">)</span>
                <span class="n">params</span><span class="p">[</span><span class="n">param</span><span class="p">]</span> <span class="o">=</span> <span class="n">value</span>

        <span class="k">for</span> <span class="n">param</span> <span class="ow">in</span> <span class="n">optional_list_params</span><span class="p">:</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">config</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;client&quot;</span><span class="p">,</span> <span class="n">param</span><span class="p">):</span>
                <span class="n">value</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">config</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;client&quot;</span><span class="p">,</span> <span class="n">param</span><span class="p">)</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s2">&quot;,&quot;</span><span class="p">)</span>
                <span class="n">params</span><span class="p">[</span><span class="n">param</span><span class="p">]</span> <span class="o">=</span> <span class="n">value</span>

        <span class="n">command</span><span class="p">[</span><span class="s2">&quot;params&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">params</span>
        <span class="n">logger</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="s2">&quot;Sending `update_site_registration` with params </span><span class="si">%s</span><span class="s2">&quot;</span><span class="p">,</span>
                     <span class="n">params</span><span class="p">)</span>
        <span class="n">response</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">msgr</span><span class="o">.</span><span class="n">send</span><span class="p">(</span><span class="n">command</span><span class="p">)</span>
        <span class="n">logger</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="s2">&quot;Recieved reponse: </span><span class="si">%s</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">response</span><span class="p">)</span>

        <span class="k">if</span> <span class="n">response</span><span class="o">.</span><span class="n">status</span> <span class="o">==</span> <span class="s2">&quot;ok&quot;</span><span class="p">:</span>
            <span class="k">return</span> <span class="bp">True</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">return</span> <span class="bp">False</span></div></div>
</pre></div>

           </div>
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2016, Gluu.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../../',
            VERSION:'2.4.4-rc',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true
        };
    </script>
      <script type="text/javascript" src="../../_static/jquery.js"></script>
      <script type="text/javascript" src="../../_static/underscore.js"></script>
      <script type="text/javascript" src="../../_static/doctools.js"></script>

  

  
  
    <script type="text/javascript" src="../../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
      });
  </script>
   

</body>
</html>